<?php

$alertsLogFileName = "/var/ossec/logs/alerts/alerts.log";
$alertsDirName = "/var/www/ossec/data/";
$lockFileName = "lock.txt";
$alertsMonitorLogFileName = "/var/www/ossec/data/AlertsMonitor.log";
$alertsName = "alerts.pos";
$logName = "/log.txt";
$tmpName = "/tmp";

$mon = array("Jan"=>"01", "Feb"=>"02", "Mar"=>"03", "Apr"=>"04", "May"=>"05", "Jun"=>"06",
	"Jul"=>"07", "Aug"=>"08", "Sep"=>"09", "Oct"=>"10", "Nov"=>"11", "Dec"=>"12");

function outLog($text) {
	$alertsMonitorLogFileName = "/var/www/ossec/prog/AlertsMonitor.log";
	$ff = fopen($alertsMonitorLogFileName, 'a');
	fwrite($ff, date("d.m.Y H:i:s")." - AlertsMonitor.php: ".$text."\n");
	fclose($ff);
}

### ПРОВЕРКА ВЫПОЛНЕНИЯ ДРУГОЙ КОПИИ ПРОГРАММЫ
#exec("ps -e | grep AlertsMonitor", $a); # Получение списка запущенных копий
#exec("ps -e w | grep -v grep | grep AlertsMonitor.php", $a); # Получение списка запущенных копий
#if (count($a) > 1) exit(); # Если другая копия выполняется - окончание работы

if (! is_file($alertsDirName.$lockFileName)) file_put_contents($alertsDirName.$lockFileName, "");
$flock = fopen($alertsDirName.$lockFileName, "r+");
if (! flock($flock, LOCK_EX | LOCK_NB)) exit();


### ПРОВЕРКА НАЛИЧИЯ ФАЙЛА С ТЕКУЩЕЙ ОБРАБОТАННОЙ ПОЗИЦИЕЙ alerts.log
if (! is_file($alertsDirName.$alertsName)) { # Если файла нет
    file_put_contents($alertsDirName.$alertsName, 0); # Создаем файл с нулевым значением
    outLog("Нет файла с текущей позицией. Создан новый");
}

### ЧТЕНИЕ ТЕКУЩЕЙ ОБРАБОТАННОЙ ПОЗИЦИИ alerts.log
$fileName = "/".date("Y-m-d_H").".log";
if (is_readable($alertsDirName.$alertsName)) { # Если файл читабельный
	$position = (int)file_get_contents($alertsDirName.$alertsName); # Считываем значение
} else {
    outLog("Сохраненный размер файла не удалось прочитать");
	exit(); # Иначе - окончание работы
}

if ($position > filesize($alertsLogFileName)) $position = 0;

### ЧТЕНИЕ ФАЙЛА ПРОТОКОЛА alerts.log
if (is_readable($alertsLogFileName)) { # Если файл читабельный
	$a = explode("** Alert ", file_get_contents ($alertsLogFileName, false , null, $position)); # Считываем значение
	file_put_contents($alertsDirName.$alertsName, filesize($alertsLogFileName)); # Записываем текущее значение обработанной позиции
} else {
    outLog("Невозможно прочитать файл протокола alerts.log");
	exit(); # Иначе - окончание работы
}

### ФОРМИРОВАНИЕ СПИСКА ХОСТОВ
$hostList = array();
$u = array();
#$command = <<<EOF
#/var/ossec/bin/manage_agents -l|grep ID|awk -F, '{print $3}'|awk -F" " '{print "echo -n " $2 " e && host " $2}'|bash|awk -F" " '{print $1 "." $6}'|awk -F. '{print $1 "." $2 "."$3 "."$4 " "$5}'
#EOF;
$command = <<<EOF
/var/ossec/bin/agent_control -la | grep ID: | awk -F, '{print $3 $2}' | awk '{print$2 " " $4}'
EOF;

exec($command, $u);
foreach ($u as $v) {
	$uu = explode(" ", $v);
	$hostList[$uu[0]] = $uu[1];
}


### ПАРСИНГ СООБЩЕНИЙ
$alerts = array();
$aMax = count($a);
for ($i=1; $i<$aMax; $i++) {
	$s = explode("\n", $a[$i]);
	
	$ss = explode(": ", $s[0]);
		$timeindex = $ss[0];
		$sss = explode(" ", $ss[1]);
		$sss = explode("- ", $ss[1]);
		$groups = $sss[1];

	$ss = explode("->", $s[1]);
		$source = $ss[1];
		$sss = explode(" ", $ss[0]);
		$date = $sss[2].".".$mon[$sss[1]].".".$sss[0];
		$time = $sss[3];
		if (count($sss) < 6) {
			$hostname = $sss[4];
			$IP = "";
		} else {
			$IP = $sss[5];
			$hostname = $hostList[$IP];
		}

	$ss = explode(") -> ", $s[2]);
		$description = str_replace("'", "", $ss[1]);
		$sss = explode(" ", $ss[0]);
		$rule = $sss[1];
		$level = $sss[3];
					
	$alerts[$hostname][$timeindex]["timeindex"] = $timeindex;
	$alerts[$hostname][$timeindex]["hostname"] = $hostname;
	$alerts[$hostname][$timeindex]["IP"] = $IP;
	$alerts[$hostname][$timeindex]["date"] = $date;
	$alerts[$hostname][$timeindex]["time"] = $time;
	$alerts[$hostname][$timeindex]["groups"] = $groups;
	$alerts[$hostname][$timeindex]["source"] = $source;
	$alerts[$hostname][$timeindex]["description"] = $description;
	$alerts[$hostname][$timeindex]["rule"] = $rule;
	$alerts[$hostname][$timeindex]["level"] = $level;

	for ($ii=3; $ii<count($s); $ii++) {
		if ($s[$ii] != "") $alerts[$hostname][$timeindex]["text"][$ii-3] = $s[$ii];
	}	
}


### ЗАПИСЬ ЛОГОВ ПО ХОСТАМ
foreach ($alerts as $hostname=>$logs) {
	krsort($logs);
	if (! is_dir($alertsDirName.$hostname)) mkdir($alertsDirName.$hostname);
	
	$hostlog = array();
	if (is_readable($alertsDirName.$hostname.$fileName)) { # Если файл читабельный
		$hostlog = unserialize(file_get_contents($alertsDirName.$hostname.$fileName)); # Считываем значение
	}
	foreach ($logs as $timeindex=>$log) {
		$hostlog[$timeindex] = $log;
	}
	file_put_contents($alertsDirName.$hostname.$tmpName, serialize($hostlog));
	rename($alertsDirName.$hostname.$tmpName, $alertsDirName.$hostname.$fileName);
}
?>

