<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">


<!-- КОРНЕВОЙ ШАБЛОН -->
<xsl:template match="/">
     <xsl:apply-templates select="ArchivFilter"/>
</xsl:template>


<!-- ФОРМИРОВАНИЕ СТРАНИЦЫ -->
<xsl:template match="ArchivFilter">
<html>
<head>
	<title>АРХИВ РЕГИСТРАЦИИ СОБЫТИЙ БЕЗОПАСНОСТИ ИНФОРМАЦИИ</title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
	<link rel="stylesheet" type="text/css" href="ArchivFilter.css"/>
	<script type="text/javascript" src="ArchivFilter.js"/>
</head>
<body>
	<pre><xsl:value-of select="@NOTE"/></pre>
	<form name="form" method="post" action="ArchivFilter.php">
	<h1>
		Выбрано <span class="count">&#160;<xsl:value-of select="@count"/>&#160;</span> сообщений
		<input type="button" id="button" class="button" name="command" value="Отобразить"/>
	</h1>
	<hr/>
	<xsl:apply-templates select="HostList"/>
	<br/><br/><hr/>
	<xsl:apply-templates select="LogList"/>
	</form>
</body>
</html>
</xsl:template>


<!-- ФОРМИРОВАНИЕ СПИСКА ХОСТОВ -->
<xsl:template match="HostList">
<div class="HostList">
	<h2>СПИСОК УСТРОЙСТВ, ДЛЯ КОТОРЫХ ИМЕЮТСЯ АРХИВНЫЕ ДАННЫЕ</h2>
	<p class="all">
	<input type="checkbox" id="HostList" name="HostList" value="HostList">
		<xsl:if test="@select = 'on'">
		<xsl:attribute name="checked">on</xsl:attribute>
		</xsl:if>
	</input>&#160;-&#160;выбрать все</p>
	<xsl:apply-templates select="Host"/>
</div>
</xsl:template>


<!-- ДАННЫЕ ПО ХОСТУ -->
<xsl:template match="Host">
<div class="Host{@null}">
	<span class="count{@null}">
	<input class="Host" type="checkbox" name="{@name}" value="Host">
		<xsl:if test="@select = 'on'">
		<xsl:attribute name="checked">on</xsl:attribute>
		</xsl:if>
	</input>
	<xsl:if test="@count != 0">
		&#160;<xsl:value-of select="@count"/>&#160;
	</xsl:if>			
	</span>
	&#160;<span class="big"><xsl:value-of select="@name"/></span>&#160;
</div>
</xsl:template>


<!-- ФОРМИРОВАНИЕ СПИСКА УРОВНЕЙ -->
<xsl:template match="LogList">
<div class="LogList">
	<h2>СПИСОК УРОВНЕЙ И ВИДОВ СООБЩЕНИЙ, ДЛЯ КОТОРЫХ ИМЕЮТСЯ АРХИВНЫЕ ДАННЫЕ</h2>
	<table cellspacing="3">
	<tr><td colspan="3">
		<p class="all">
		<input type="checkbox" id="LogList" name="LogList" value="LogList">
			<xsl:if test="@select = 'on'">
			<xsl:attribute name="checked">on</xsl:attribute>
			</xsl:if>
		</input>&#160;-&#160;выбрать все</p>
	</td><td name="{@level}" class="visible">&#160;&#160;Код
	</td><td name="{@level}" class="visible">&#160;&#160;Группы
	</td><td name="{@level}" class="visible">&#160;&#160;Сообщение
	</td></tr>
	<xsl:apply-templates select="Level"/>
	</table>
</div>
</xsl:template>


<!-- ДАННЫЕ ПО УРОВНЮ -->
<xsl:template match="Level">
<tr><td><a name="group" id="{@level}">+<xsl:value-of select="count(Rule)"/></a>
</td><td class="alert{@alert}{@null}">
	<span class="count{@null}">
	<input type="checkbox" id="Level{@level}" name="Level{@level}" value="Level">
		<xsl:if test="@select = 'on'">
		<xsl:attribute name="checked">on</xsl:attribute>
		</xsl:if>
	</input>
	&#160;<xsl:value-of select="@count"/>&#160;</span>
</td><td class="alert{@alert}{@null}" colspan="4">
	&#160;<span class="bold"><xsl:value-of select="@level"/>&#160;уровень</span>
</td></tr>
	<xsl:apply-templates select="Rule">
		<xsl:sort select="@rule" order="ascending"/>
	</xsl:apply-templates>
</xsl:template>


<!-- ДАННЫЕ ПО ПРАВИЛУ -->
<xsl:template match="Rule">
<tr>
	<xsl:if test="@count = 0">
	<xsl:attribute name="name"><xsl:value-of select="../@level"/></xsl:attribute>
	<xsl:attribute name="class">hidden</xsl:attribute>
	</xsl:if>
<td></td><td class="right"><xsl:value-of select="position()"/>
</td><td class="alert-{../@alert}{@null}">
	<span class="count{@null}">
	<input class="Level{../@level}" type="checkbox" name="{@rule}" value="Rule">
		<xsl:if test="@select = 'on'">
		<xsl:attribute name="checked">on</xsl:attribute>
		</xsl:if>
	</input>
	&#160;<xsl:value-of select="@count"/>&#160;</span>
</td><td class="alert-{../@alert}{@null} bold">
	<xsl:value-of select="@rule"/>
</td><td class="alert-{../@alert}{@null}">
	<xsl:value-of select="@groups"/>
</td><td class="alert-{../@alert}{@null}">
	<xsl:value-of select="@description"/>
</td></tr>
</xsl:template>


</xsl:stylesheet>
