<?php
putenv("KRB5CCNAME={$_SERVER['KRB5CCNAME']}");

$ossecConfFileName = "/var/ossec/etc/ossec.conf";
$rulesDirName = "/var/ossec/rules/";
$alertsDirName = "../data/";
$alertsLevelFileName = "alerts.level";
$xmlFileName = '../data/RuleList.xml';

$newRuleList = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<RuleList>
</RuleList>
XML;

$newRuleList = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<?xml-stylesheet type='text/xsl' href='RuleList.xsl' media='screen'?>
<RuleList>
</RuleList>
XML;

$newrules = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<rules>
XML;

$alertsLevel = array(0,1,0,1,2,2,2,2,2,2,3,3,3,3,3,3);
if (! is_file($alertsDirName.$alertsLevelFileName)) {
	file_put_contents($alertsDirName.$alertsLevelFileName, serialize($alertsLevel));
}
if (is_readable($alertsDirName.$alertsLevelFileName)) {
	$alertsLevel = unserialize(file_get_contents($alertsDirName.$alertsLevelFileName));
}

$alertLevels = array(0,0,0,0);
$alertText = array("выключение","сообщение","ВНИМАНИЕ","ТРЕВОГА");

$s = explode("<!--", file_get_contents($ossecConfFileName));
$r = $s[0];
for ($i=1; $i<count($s); $i++) {
	$ss = explode("-->", $s[$i]);
	$r = $r.$ss[1];
}
$ossecConf = new SimpleXMLElement($r);

$r = $newrules;
foreach ($ossecConf->rules->children() as $ruleFileName) {
	$r = $r.'<File file="'.$rulesDirName.$ruleFileName.'">';
	$s = explode("<!--", file_get_contents($rulesDirName.$ruleFileName));
	$r = $r.$s[0];
	for ($i=1; $i<count($s); $i++) {
		$ss = explode("-->", $s[$i]);
		$r = $r.$ss[1];
	}
	$r = $r.'</File>';
}
$r = $r."</rules>";
$rules = new SimpleXMLElement($r);

$Rule = array();
foreach ($rules->children() as $File) {
foreach ($File->children() as $group) {
	foreach ($group->children() as $rule) {
		$Rule[(string)$rule["level"]][(string)$group["name"]][(string)$rule["id"]]["description"] = $rule->description;
		$Rule[(string)$rule["level"]][(string)$group["name"]][(string)$rule["id"]]["file"] = $File["file"];
	}
}}

$RuleList = new SimpleXMLElement($newRuleList);
krsort($Rule);
foreach ($Rule as $level=>$groups) {
	if ($level == 0) break;
	$Level = $RuleList->addChild("Level");
	$Level["level"] = $level;
	$Level["alert"] = $alertsLevel[$level];
	$Level["alertname"] = $alertText[$alertsLevel[$level]];
	ksort($groups);
	foreach ($groups as $group=>$rules) {
		$Group = $Level->addChild("Group");
		$Group["name"] = $group;
		ksort($rules);
		foreach ($rules as $id=>$parm) {
			$Rule = $Group->addChild("Rule");
			$Rule["id"] = $id;
			$Rule["description"] = $parm["description"];
			$Rule["file"] = $parm["file"];
		}
	}
}

#$RuleList->asXML($xmlFileName);
header("Content-Type: text/xml");
echo $RuleList->asXML();
?>
