<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">


<!-- КОРНЕВОЙ ШАБЛОН -->
<xsl:template match="/">
     <xsl:apply-templates select="RuleList"/>
</xsl:template>


<!-- ФОРМИРОВАНИЕ СТРАНИЦЫ -->
<xsl:template match="RuleList">
<html>
<head>
	<title>ПЕРЕЧЕНЬ РЕГИСТРИРУЕМЫХ СОБЫТИЙ БЕЗОПАСНОСТИ ИНФОРМАЦИИ</title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
	<link rel="stylesheet" type="text/css" href="ArchivFilter.css"/>
	<!--script type="text/javascript" src="ArchivFilter.js"/-->
</head>
<body>
	<pre><xsl:value-of select="@NOTE"/></pre>
	<h1>ПЕРЕЧЕНЬ РЕГИСТРИРУЕМЫХ СОБЫТИЙ БЕЗОПАСНОСТИ ИНФОРМАЦИИ</h1>
<div class="LogList">
	<table cellspacing="3">
	<tr>
		<td class="visible">&#160;Уровень</td>
		<td class="visible">Группа</td>
		<td class="visible right">Код</td>
		<td class="visible">Событие</td>
		<td class="visible">Файл с описанием</td>
	</tr>
	<xsl:apply-templates select="Level"/>
	</table>
</div>
</body>
</html>
</xsl:template>


<!-- ДАННЫЕ ПО УРОВНЮ -->
<xsl:template match="Level">
<tr><td class="alert{@alert}{@null}" colspan="4">
	&#160;<span class="bold right"><xsl:value-of select="@level"/>&#160;уровень - <xsl:value-of select="@alertname"/></span>
</td></tr>
	<xsl:apply-templates select="Group">
		<xsl:sort select="@name" order="ascending"/>
	</xsl:apply-templates>
</xsl:template>


<!-- ДАННЫЕ ПО ГРУППЕ -->
<xsl:template match="Group">
<tr>
<td>&#160;&#160;&#160;&#160;&#160;</td><td class="alert-{../@alert} bold left" colspan="3">
	<xsl:value-of select="@name"/>
</td></tr>
	<xsl:apply-templates select="Rule">
		<xsl:sort select="@id" order="ascending"/>
	</xsl:apply-templates>
</xsl:template>


<!-- ДАННЫЕ ПО ПРАВИЛУ -->
<xsl:template match="Rule">
<tr><td>&#160;&#160;&#160;&#160;&#160;</td><td>&#160;&#160;&#160;&#160;&#160;
</td><td class="alert-{../../@alert} right">
	<xsl:value-of select="@id"/>
</td><td class="alert-{../../@alert}">
	<xsl:value-of select="@description"/>
</td><td>
	<xsl:value-of select="@file"/>
</td></tr>
</xsl:template>


</xsl:stylesheet>
