<?php

putenv("KRB5CCNAME={$_SERVER['KRB5CCNAME']}");
#print_r($_GET);

function makeChild($Child, $a) {
	foreach ($a as $k=>$v) {
		if (is_array($v)) {
			for ($i=0; $i<count($v); $i++) {
				$Log = $Child->addChild("Log");
				$Log[$k] = $v[$i];
			}
		} else $Child[$k] = $v;
	}

	return $Child;
}

$alertsDirName = "/var/www/ossec/data/";
#$alertsDirName = "../data/";
$alertsLevelFileName = "alerts.level";
$xmlFileName = "../data/Unit.xml";

$newUnit = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<Unit>
</Unit>
XML;

$newUnit = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<?xml-stylesheet type="text/xsl" href="Unit.xsl" media="screen"?>
<Unit>
</Unit>
XML;

$alertLevel = array(0,1,1,1,1,1,2,2,2,2,2,3,3,3,3,3);
if (is_readable($alertsDirName.$alertsLevelFileName)) {
	$alertLevel = unserialize(file_get_contents($alertsDirName.$alertsLevelFileName));
}

$alertLevels = array(0,0,0,0);

if (! isset($_GET["HostDir"])) exit();
$hostDir = $_GET["HostDir"];
#$hostDir = "client";
#$hostDir = "=server";


$Unit = new SimpleXMLElement($newUnit);
$Unit["HostDir"] = $hostDir;
$Unit["Name"] = $hostDir;
$Unit["Time"] = date("G ч. i мин.");
$Unit["Date"] = date("d.m.Y");

if (count($_GET) <= 1) $_GET = array("Group" => "on", "Alert0" => "on", "Alert1" => "on",
	"Alert2" => "on", "Alert3" => "on");
if (array_key_exists("Group", $_GET)) $Unit["Group"] = "on";
if (array_key_exists("Alert0", $_GET)) $Unit["ViewAlert0"] = "on";
if (array_key_exists("Alert1", $_GET)) $Unit["ViewAlert1"] = "on";
if (array_key_exists("Alert2", $_GET)) $Unit["ViewAlert2"] = "on";
if (array_key_exists("Alert3", $_GET)) $Unit["ViewAlert3"] = "on";

if (is_dir($alertsDirName.$hostDir)) {
	$logNames = glob($alertsDirName.$hostDir."/*.log");
	rsort($logNames);
	foreach ($logNames as $logName) {
		if (is_readable($logName)) {
			$logs = unserialize(file_get_contents($logName));
			foreach ($logs as $timeindex=>$log) {
				$alertLevels[$alertLevel[$log["level"]]] += 1;
				if ((count($Unit->Children()) < 1000)
				&& ((($Unit["ViewAlert0"] == "on") && ($alertLevel[$log["level"]] == 0))
				|| (($Unit["ViewAlert1"] == "on") && ($alertLevel[$log["level"]] == 1))
				|| (($Unit["ViewAlert2"] == "on") && ($alertLevel[$log["level"]] == 2))
				|| (($Unit["ViewAlert3"] == "on") && ($alertLevel[$log["level"]] == 3))))
				{
					$unicum = true;
					if (isset($Unit["Group"]) && ($Unit["Group"]= "on")) {
						$s = substr(preg_replace('~[ ]+~i', ' ', trim(strtolower(implode("", $log["text"])))), 0, 100);
						foreach ($Unit->Children() as $Alert) {
							if ($Alert["rule"] == $log["rule"]) {
								$procent = 0;
								$n = similar_text ($Alert["s"], $s, $procent);
								if ($procent > 90) {
									if (count($Alert->Children()) < 1000) {
										$Group = $Alert->addChild("Group");
										makeChild($Group, $log);									
										$Group["AlertLevel"] = $alertLevel[$log["level"]];
									}
									$Alert["n"] += 1;
									$Alert["t"] = min($Alert["t"], (int)$log["timeindex"]);
									$unicum = false;
									break;
								}
							}
						}
					}
					if ($unicum) {
						$Alert = $Unit->addChild("Alert");
						makeChild($Alert, $log);
						$Alert["AlertLevel"] = $alertLevel[$log["level"]];
						$Alert["s"] = substr(preg_replace('~[ ]+~i', ' ', trim(strtolower(implode("", $log["text"])))), 0, 100);
						$Alert["n"] = 1;
						$Alert["t"] = (int)$log["timeindex"];
					}
				}
			}
		}
	}
}

foreach ($Unit->Children() as $Alert) {
	$dt = (int)$Alert["timeindex"] - $Alert["t"] + 1;
	$d = (int)($dt / 86400);
	$dd = $dt - (86400*$d);
	$h = (int)($dd / 3600);
	$hh = $dd - 3600*$h;
	$m = (int)($hh / 60 + 1);
	$Alert["t"] = "";
	if ($d > 0) $Alert["t"] = $d."д";
	if ($h > 0) $Alert["t"] = $Alert["t"].$h."ч";
	if ($m > 0) $Alert["t"] = $Alert["t"].$m."м";
}

$Unit["All"] = array_sum($alertLevels);
$Unit["Alert0"] = $alertLevels[0];
$Unit["Alert1"] = $alertLevels[1];
$Unit["Alert2"] = $alertLevels[2];
$Unit["Alert3"] = $alertLevels[3];

#$Unit->asXML($xmlFileName);
header("Content-Type: text/xml");
echo $Unit->asXML();
?>

