<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">


<!-- КОРНЕВОЙ ШАБЛОН -->
<xsl:template match="/">
     <xsl:apply-templates select="Unit"/>
</xsl:template>


<!-- ФОРМИРОВАНИЕ СТРАНИЦЫ -->
<xsl:template match="Unit">
<html>
<head>
	<title><xsl:value-of select="@HostDir"/>: СОБЫТИЯ БЕЗОПАСНОСТИ ИНФОРМАЦИИ <xsl:value-of select="@worktime"/></title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
	<_meta http-equiv="Refresh" content="3" url="Unit.php" target="_self"/>
	<link rel="stylesheet" type="text/css" href="Unit.css"/>
	<script type="text/javascript" src="Unit.js"/>
</head>
<body>
	<div class="header">
		<xsl:call-template name="PageHeader">
			<xsl:with-param name="Form">Form</xsl:with-param>
		</xsl:call-template>
		<table class="header" cellspacing="2">
		<xsl:call-template name="TableHeader"/>
		</table>
	</div>
	<xsl:call-template name="PageHeader">
		<xsl:with-param name="Form"></xsl:with-param>
	</xsl:call-template>
	<table class="unit" cellspacing="2">
	<xsl:call-template name="TableHeader"/>
	<xsl:apply-templates select="Alert">
		<xsl:sort select="@timeindex" order="descending"/>
	</xsl:apply-templates>
	</table>	
</body>
</html>
</xsl:template>


<!-- ФОРМИРОВАНИЕ НЕПОДВИЖНОГО ЗАГОЛОВКА СТРАНИЦЫ -->
<xsl:template name="PageHeader">
	<xsl:param name="Form"></xsl:param>
	<div class="summary">
		<h1>Устройство <span class="h1"><xsl:value-of select="@Name"/></span> - события безопасности информации 
		по состоянию на <span class="h1bold"><xsl:value-of select="@Time"/></span></h1>
		<form name="form" method="get" action="Unit.php">
		<input type="hidden" name="HostDir" value="{@HostDir}"/>
		<table class="summary" cellspacing="6"><tr>
		<xsl:if test='$Form = "Form"'>
			<td class="summary left" width='10%'>Групп.
				<input type="checkbox" name="Group">
					<xsl:if test="@Group = 'on'">
					<xsl:attribute name="checked">on</xsl:attribute>
					</xsl:if>
				</input>
				<xsl:if test="@Group = 'on'">&#160;вкл.</xsl:if>
				<xsl:if test="count(@Group) = 0">&#160;выкл.</xsl:if>
			</td><td class="summary right" width='10%'>				
				Из&#160;<span class="bold"><xsl:value-of select="@All"/></span>&#160;событий:
			</td><td class="alert3" width='10%'>
				<input type="checkbox" name="Alert3">
					<xsl:if test="@ViewAlert3 = 'on'">
					<xsl:attribute name="checked">on</xsl:attribute>
					</xsl:if>
				</input>&#160;
				<xsl:value-of select="@Alert3"/>&#160;-&#160;ТРЕВОГА
			</td><td class="alert2" width='10%'>
				<input type="checkbox" name="Alert2">
					<xsl:if test="@ViewAlert2 = 'on'">
					<xsl:attribute name="checked">on</xsl:attribute>
					</xsl:if>
				</input>&#160;
				<xsl:value-of select="@Alert2"/>&#160;-&#160;ВНИМАНИЕ
			</td><td class="alert1" width='10%'>
				<input type="checkbox" name="Alert1">
					<xsl:if test="@ViewAlert1 = 'on'">
					<xsl:attribute name="checked">on</xsl:attribute>
					</xsl:if>
				</input>&#160;
				<xsl:value-of select="@Alert1"/>&#160;-&#160;сообщения
			</td><td class="alert0" width='10%'>
				<input type="checkbox" name="Alert0">
					<xsl:if test="@ViewAlert0 = 'on'">
					<xsl:attribute name="checked">on</xsl:attribute>
					</xsl:if>
				</input>&#160;
				<xsl:value-of select="@Alert0"/>&#160;-&#160;выключение
			</td>
		</xsl:if><xsl:if test='$Form != "Form"'>
			<td class="summary" width='10%'>ВНИМАНИЕ</td>
		</xsl:if>
		</tr></table>	
		</form>
	</div>
</xsl:template>


<!-- ФОРМИРОВАНИЕ ЗАГОЛОВКА ТАБЛИЦЫ -->
<xsl:template name="TableHeader">
	<tr>
		<th width='3%' rowspan="2">№<br/>п/п</th>
		<th width='4%' rowspan="2">Уро-<br/>вень</th>
		<th width='13%' rowspan="2">Время,&#160;дата</th>
		<th width='80%'>
			<div class="left-position">&#160;&#160;&#160;Событие (Код)</div>
			<div class="right-position">Источник&#160;&#160;&#160;</div>
			<br/>Описание
		</th>
	</tr>
</xsl:template>


<!-- ДАННЫЕ О СОБЫТИИ -->
<xsl:template match="Alert">
	<tr><td colspan="6"></td></tr>
	<tr><td class="alert-{@AlertLevel} center">
		<p><xsl:value-of select="position()"/></p>
	</td><td class='level alert{@AlertLevel} center'>
		<xsl:value-of select="@level"/>
	</td><td class="alert-{@AlertLevel}">
		<xsl:value-of select="@time"/>
		<xsl:if test="@date != //Unit/@Date">
			&#160;&#160;<xsl:value-of select='@date'/>
		</xsl:if>			
		<xsl:if test="@n > 1">
			<br/><a name="group" id="{@timeindex}" class="alert{@AlertLevel}">
			&#160;<span class="bold"><xsl:value-of select='@n'/></span> соб. за <span class="bold"><xsl:value-of select='@t'/></span>&#160;</a>
		</xsl:if>			
	</td><td class="alert-{@AlertLevel} left">
		<div class="left-position"><span class="bold"><xsl:value-of select="@description"/></span> (<xsl:value-of select="@rule"/>)&#160;&#160;&#160;</div>
		<div class="right-position"><xsl:value-of select="@source"/></div>
		<br/>
		<xsl:for-each select="Log">
			<p><xsl:value-of select="@text"/></p>
		</xsl:for-each>
	</td></tr>
	<xsl:apply-templates select="Group">
		<xsl:sort select="@timeindex" order="descending"/>
	</xsl:apply-templates>
</xsl:template>


<!-- ДАННЫЕ О СГРУППИРОВАННЫХ СОБЫТИЯХ -->
<xsl:template match="Group">
	<tr name="{../@timeindex}" class="hidden">
	<th></th><th><p><xsl:value-of select="position()+1"/></p></th>
	<td class="alert-{@AlertLevel}">
		<xsl:value-of select="@time"/>
		<xsl:if test="@date != //Unit/@Date">
			&#160;&#160;<xsl:value-of select='@date'/>
		</xsl:if>
	</td><td class="alert-{@AlertLevel} left">
		<xsl:for-each select="Log">
			<p><xsl:value-of select="@text"/></p>
		</xsl:for-each>
	</td></tr>
</xsl:template>

</xsl:stylesheet>
