<?php
putenv("KRB5CCNAME={$_SERVER['KRB5CCNAME']}");

function countLevels($hostDir) {
	$logName = "/log.txt";
	$levels = array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
	if (is_dir($hostDir)) {
		$logNames = glob($hostDir."/*.log");
		rsort($logNames);
		foreach ($logNames as $logName) {
			if (is_readable($logName)) {
				$logs = unserialize(file_get_contents($logName));
				krsort($logs);
				foreach ($logs as $timeindex=>$log) {
					if ($levels[0] == 0) $levels[0] = $log["level"];
					$levels[$log["level"]] += 1;
				}
			}
		}
	}
	return $levels;
}

function makeChild($Child, $a) {
	foreach ($a as $k=>$v) {
		if (is_array($v)) {
			for ($i=0; $i<count($v); $i++) {
				$Log = $Child->addChild("Log");
				$Log[$k] = $v[$i];
			}
		} else $Child[$k] = $v;
	}
	return $Child;
}

$alertsDirName = "/var/www/ossec/data/";
#$alertsDirName = "../data/";
$logName = "/log.txt";
$alertsLevelFileName = "alerts.level";
$xmlFileName = '../data/UnitList.xml';

$newUnitList = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<UnitList>
</UnitList>
XML;

$newUnitList = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<?xml-stylesheet type="text/xsl" href="UnitList.xsl" media="screen"?>
<UnitList>
</UnitList>
XML;

$alertsLevel = array(0,1,0,1,2,2,2,2,2,2,3,3,3,3,3,3);
if (! is_file($alertsDirName.$alertsLevelFileName)) {
	file_put_contents($alertsDirName.$alertsLevelFileName, serialize($alertsLevel));
}
if (is_readable($alertsDirName.$alertsLevelFileName)) {
	$alertsLevel = unserialize(file_get_contents($alertsDirName.$alertsLevelFileName));
}

$u = array();
$u = glob($alertsDirName."/*", GLOB_ONLYDIR);
$units = array();
foreach ($u as $v) {
	$unitname = basename($v);
	$units[$unitname]["Name"] = $unitname;
#	$units[$unitname]["IP"] = "";
}

ksort($units);

#print_r($units);

if (count($_GET) == 0) $_GET = array("Alert1" => "on", "Alert2" => "on", "Alert3" => "on");

$UnitList = new SimpleXMLElement($newUnitList);
$UnitList["Time"] = date("G ч. i мин. s сек.");
$UnitList["Date"] = date("d.m.Y");
if (array_key_exists("Alert1", $_GET)) $UnitList["ViewAlert1"] = "on";
if (array_key_exists("Alert2", $_GET)) $UnitList["ViewAlert2"] = "on";
if (array_key_exists("Alert3", $_GET)) $UnitList["ViewAlert3"] = "on";

foreach ($units as $hostDir=>$u) {
	$Unit = $UnitList->addChild('Unit');
	$Unit["HostDir"] = $hostDir;
	foreach ($u as $k=>$v) $Unit[$k] = $v;
	$levels = countLevels($alertsDirName.$hostDir);

	$Unit["Alert0"] = 0;
	$Unit["Alert1"] = 0;
	$Unit["Alert2"] = 0;
	$Unit["Alert3"] = 0;
	for ($l=1; $l<16; $l++) {
		if ($alertsLevel[$l] == 0) $Unit["Alert0"] += $levels[$l];
		elseif ($alertsLevel[$l] == 1) $Unit["Alert1"] += $levels[$l];
		elseif ($alertsLevel[$l] == 2) $Unit["Alert2"] += $levels[$l];
		else $Unit["Alert3"] += $levels[$l];
	}
	$Unit['Status'] = -1;
	if (($Unit['Alert1'] + $Unit['Alert2'] + $Unit['Alert3']) > 0) $Unit['Status'] = 1;
	if ($levels[0] == 2) $Unit['Status'] = 0;
	unset($levels);
}

$UnitList["All"] = count($UnitList->children());
$UnitList["On"] = 0;
$UnitList["Off"] = 0;
$UnitList["Not"] = 0;
$UnitList["Alert0"] = 0;
$UnitList["Alert1"] = 0;
$UnitList["Alert2"] = 0;
$UnitList["Alert3"] = 0;

foreach ($UnitList->children() as $Unit) {
	if ($Unit["Status"] == -1) $UnitList["Not"] += 1;
	elseif ($Unit["Status"] == 0) $UnitList["Off"] += 1;
	$UnitList["On"] = $UnitList["All"] - $UnitList["Not"] - $UnitList["Off"];
	if ($Unit["Alert0"] > 0) $UnitList["Alert0"] += 1;
	if ($Unit["Alert1"] > 0) $UnitList["Alert1"] += 1;
	if ($Unit["Alert2"] > 0) $UnitList["Alert2"] += 1;
	if ($Unit["Alert3"] > 0) $UnitList["Alert3"] += 1;
}

$FHL = array();
$HL = glob($alertsDirName."*", GLOB_ONLYDIR);
sort($HL);

foreach ($HL as $H) {
	$FL = glob($alertsDirName.basename($H)."/*.log");
	rsort($FL);
	foreach ($FL as $F) {
		$FHL[basename($F, ".log")][basename($H)] = $F;
	}
}
krsort($FHL);

$TTT = time();
$AlertList = $UnitList->addChild("AlertList");
foreach ($FHL as $F=>$HL) {
	$AL = array();
	foreach ($HL as $H=>$L) {
		$A = unserialize(file_get_contents($L));
		$AL = $AL + $A;
	}
	krsort($AL);

	foreach ($AL as $T=>$A) {
		if ((array_key_exists("On", $_GET) && ($alertsLevel[$A["level"]] == 1))
		|| (array_key_exists("Off", $_GET) && ($alertsLevel[$A["level"]] == 0))
		|| (array_key_exists("Alert0", $_GET) && ($alertsLevel[$A["level"]] == 0))
		|| (array_key_exists("Alert1", $_GET) && ($alertsLevel[$A["level"]] == 1))
		|| (array_key_exists("Alert2", $_GET) && ($alertsLevel[$A["level"]] == 2))
		|| (array_key_exists("Alert3", $_GET) && ($alertsLevel[$A["level"]] == 3))) {
			$Alert = $AlertList->addChild("Alert");
			makeChild($Alert, $A);
			$Alert["AlertLevel"] = $alertsLevel[$A["level"]];
			$dT = $TTT - $A["timeindex"];
			if ($dT <= 600) $Alert["DeltaT"] = 0;
			elseif ($dT <= 1800) $Alert["DeltaT"] = 1;
			elseif ($dT <= 3600) $Alert["DeltaT"] = 2;
			else $Alert["DeltaT"] = 3;
		}
	}
	if (count($AlertList->Children()) > 1000) break;
}

if (array_key_exists("On", $_GET)) $UnitList["ViewOn"] = "on";
if (array_key_exists("Off", $_GET)) $UnitList["ViewOff"] = "on";
if (array_key_exists("Not", $_GET)) $UnitList["ViewNot"] = "on";
if (array_key_exists("Alert0", $_GET)) $UnitList["ViewAlert0"] = "on";
if (array_key_exists("Alert1", $_GET)) $UnitList["ViewAlert1"] = "on";
if (array_key_exists("Alert2", $_GET)) $UnitList["ViewAlert2"] = "on";
if (array_key_exists("Alert3", $_GET)) $UnitList["ViewAlert3"] = "on";



#$UnitList["NOTE"] = $NOTE;
#$UnitList->asXML($xmlFileName);
header("Content-Type: text/xml");
echo $UnitList->asXML();
?>

