<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- КОРНЕВОЙ ШАБЛОН -->
<xsl:template match="/">
     <xsl:apply-templates select="UnitList"/>
     <xsl:apply-templates select="AlertList"/>
</xsl:template>

<!-- ФОРМИРОВАНИЕ СТРАНИЦЫ -->
<xsl:template match="UnitList">
<html>
<head>
	<title><xsl:value-of select="@Time"/>&#160;-&#160;РЕГИСТРАЦИЯ СОБЫТИЙ БЕЗОПАСНОСТИ ИНФОРМАЦИИ</title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
	<meta http-equiv="Refresh" content="3" url="UnitList.php" target="_blank"/>
	<link rel="stylesheet" type="text/css" href="UnitList.css"/>
	<script type="text/javascript" src="UnitList.js"/>
</head>
<body>
	<div id="pageheader" class="header">
		<xsl:value-of select="@NOTE"/>
		<xsl:call-template name="PageHeader"/>
		<xsl:call-template name="UnitList"/>
		<table class="summary" cellspacing="6"><tr>
			<td class="summary" width='10%'>
				Полученные события:
			</td><td class="dt0 bold" width='10%'>
				менее 10 минут назад
			</td><td class="dt1 bold" width='10%'>
				от 10 до 30 минут назад
			</td><td class="dt2 bold" width='10%'>
				от 30 минут до 1 часа назад
			</td><td class="dt3 bold" width='10%'>
				более 1 часа назад
			</td>
		</tr></table>	
		
		<table class="summary" cellspacing="2">
		<xsl:call-template name="TableHeader"/>
		</table>
	</div>
	<div id="blank"></div>
	<div class="alerts">
		<table class="alert" cellspacing="2">
		<xsl:apply-templates select="AlertList"/>
		</table>
	</div>
</body>
</html>
</xsl:template>

<!-- ФОРМИРОВАНИЕ НЕПОДВИЖНОЙ ВЕРХНЕЙ ЧАСТИ СТРАНИЦЫ -->
<xsl:template name="PageHeader">
	<div class="summary">
		<table class="unit"><tr><td>
			<h1>События безопасности информации по состоянию на <span class="h1bold"><xsl:value-of select="@Time"/></span></h1>
		</td><td>
			<p class="menu">
				<a class="menu" href="ArchivFilter.php" target="_blank">Архив</a>
				&#160;&#160;&#160;&#160;&#160;
				<a class="menu" href="RuleList.php" target="_blank">Перечень событий</a>
				&#160;&#160;&#160;&#160;&#160;
				<a class="menu" href="ClearLogs.php" target="_blank">Настройка отображения</a>
			</p>
		</td></tr></table>
		<form name="form" method="get" action="UnitList.php">
		<table class="summary" cellspacing="6"><tr>
			<td class="summary right" width='1%'>
				Из&#160;<b><xsl:value-of select="@All"/></b>&#160;устройств:
			</td>
			<xsl:if test="(@On != 0)">
				<td class="status1" width='5%'>
				<b><xsl:value-of select="@On"/></b>&#160;-&#160;включено
				</td>
			</xsl:if>
			<xsl:if test="(@Off != 0)">
				<td class="status0" width='5%'>
				<b><xsl:value-of select="@Off"/></b>&#160;-&#160;выключено
				</td>
			</xsl:if>
			<xsl:if test="(@Not != 0)">
				<td class="status-1" width='5%'>
				<b><xsl:value-of select="@Not"/></b>&#160;-&#160;нет&#160;данных
				</td>
			</xsl:if>
			<td class="summary right" width='20%'>
				Распределение&#160;событий&#160;по&#160;устройствам:
			</td><td class="alert3 bold" width='10%'>
				<input type="checkbox" name="Alert3">
					<xsl:if test="@ViewAlert3 = 'on'">
					<xsl:attribute name="checked">on</xsl:attribute>
					</xsl:if>
				</input>
				<xsl:value-of select="@Alert3"/>&#160;-&#160;ТРЕВОГА
			</td><td class="alert2 bold" width='10%'>
				<input type="checkbox" name="Alert2">
					<xsl:if test="@ViewAlert2 = 'on'">
					<xsl:attribute name="checked">on</xsl:attribute>
					</xsl:if>
				</input>
				<xsl:value-of select="@Alert2"/>&#160;-&#160;ВНИМАНИЕ
			</td><td class="summary" width='1%'>
				<input type="checkbox" name="Alert1">
					<xsl:if test="@ViewAlert1 = 'on'">
					<xsl:attribute name="checked">on</xsl:attribute>
					</xsl:if>
				</input>
			</td>
				<td class="alert1 bold" width='10%'>
				<xsl:value-of select="@Alert1"/>&#160;-&#160;Сообщения&#160;
			</td>
			<xsl:if test="(@Alert0 != 0)">
				<td class="alert0 bold" width='10%'>
				<xsl:value-of select="@Alert0"/>&#160;-&#160;Выключение
				</td>
			</xsl:if>
			<xsl:if test="(@Not != 0)">
				<td class="status-1 bold" width='10%'>
				<b><xsl:value-of select="@Not"/></b>&#160;-&#160;нет&#160;данных
				</td>
			</xsl:if>
		</tr></table>
		</form>
	</div>
</xsl:template>

<!-- ФОРМИРОВАНИЕ СПИСКА УСТРОЙСТВ -->
<xsl:template name="UnitList">
	<div class="units">
	<xsl:for-each select="Unit">
	<xsl:if test="(((//UnitList/@ViewAlert1 = 'on') and (@Status = -1))
		or ((//UnitList/@ViewAlert1 = 'on') and (@Alert0 > 0))
		or ((//UnitList/@ViewAlert1 = 'on') and (@Alert1 > 0))
		or ((//UnitList/@ViewAlert2 = 'on') and (@Alert2 > 0))
		or ((//UnitList/@ViewAlert3 = 'on') and (@Alert3 > 0)))">
		<div class='unit level{@Level}' id='{@ID}' name='unit'>
		<table class="unit" cellspacing="0"><tr>
		<xsl:if test='@Alert3 > 0'>
			<td class="alert3" width='1%'>
			<a class="white level bold" href='Unit.php?HostDir={@HostDir}&amp;Alert3=on' target='_blank'>
			    <xsl:value-of select="@Alert3"/>
			</a>
			</td>
		</xsl:if>
		<xsl:if test='@Alert2 > 0'>
			<td class="alert2" width='1%'>
			<a class="level bold" href='Unit.php?HostDir={@HostDir}&amp;Alert2=on' target='_blank'>
			    <xsl:value-of select="@Alert2"/>
			</a>
			</td>
		</xsl:if>
		<xsl:if test='@Alert1 > 0'>
			<td class="alert1 level bold" width='1%'>
			<a class="white level bold" href='Unit.php?HostDir={@HostDir}&amp;Alert1=on' target='_blank'>
			    <xsl:value-of select="@Alert1"/>
			</a>
			</td>
		</xsl:if>
		<xsl:if test='@Alert0 > 0'>
			<td class="alert0 level bold" width='1%'>
			<a class="level bold" href='Unit.php?HostDir={@HostDir}&amp;Alert0=on' target='_blank'>
			    <xsl:value-of select="@Alert0"/>
			</a>
			</td>
		</xsl:if>
		<td class='status{@Status}' width='*'>
			<a href='Unit.php?HostDir={@HostDir}' target='_blank'>
			<span class="level bold"><xsl:value-of select="@Name"/></span>
			<br/><xsl:value-of select="@IP"/>
			</a>
		</td>
		</tr></table>
		</div>
	</xsl:if>
	</xsl:for-each>
	</div>
</xsl:template>


<!-- ФОРМИРОВАНИЕ ЗАГОЛОВКА ТАБЛИЦЫ -->
<xsl:template name="TableHeader">
	<tr>
		<th width='3%'>№<br/>п/п</th>
		<th width='15%'>Устройство</th>
		<th width='4%'>Уро-<br/>вень</th>
		<th width='13%'>Время,&#160;дата</th>
		<th width='65%'>
			<div class="left-position">&#160;&#160;&#160;<b>Событие</b> (Код)</div>
			<div class="right-position">Источник&#160;&#160;&#160;</div>
			<br/><p>&#160;Описание</p>
		</th>
	</tr>
</xsl:template>

<!-- ФОРМИРОВАНИЕ СПИСКА СОБЫТИЙ -->
<xsl:template match="AlertList">
	<xsl:apply-templates select="Alert"/>
</xsl:template>

<!-- ДАННЫЕ О СОБЫТИИ -->
<xsl:template match="Alert">
	<tr><td width='3%' class="dt{@DeltaT} center bold">
		<xsl:value-of select="position()"/>
	</td><td width='15%' class="dt{@DeltaT} level bold">
		<xsl:value-of select="@hostname"/>
	</td><td width='4%' class='level alert{@AlertLevel} bold center'>
		<xsl:value-of select="@level"/>
	</td><td width='13%' class="alert-{@AlertLevel}"><span class="bold">
		<xsl:value-of select="@time"/>
		<xsl:if test="@date != //UnitList/@Date">
			&#160;&#160;<xsl:value-of select='@date'/>
		</xsl:if></span>
	</td><td width='65%' class="alert-{@AlertLevel}">
		<div class="left-position">&#160;&#160;&#160;<span class="bold"><xsl:value-of select="@description"/></span> (<xsl:value-of select="@rule"/>)</div>
		<div class="right-position"><xsl:value-of select="@source"/>&#160;&#160;&#160;</div>
		<br/>
		<xsl:for-each select="Log">
			<p><xsl:value-of select="@text"/></p>
		</xsl:for-each>
	</td></tr>
</xsl:template>

</xsl:stylesheet>
